'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = undefined;

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _class, _class2, _temp;

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _mobxReact = require('mobx-react');

var _ramda = require('ramda');

var _ramda2 = _interopRequireDefault(_ramda);

var _invariant = require('invariant');

var _invariant2 = _interopRequireDefault(_invariant);

var _FieldStore = require('./containers/FieldStore');

var _FieldStore2 = _interopRequireDefault(_FieldStore);

var _prepareProps2 = require('./utils/prepareProps');

var _prepareProps3 = _interopRequireDefault(_prepareProps2);

var _getValue = require('./utils/getValue');

var _getValue2 = _interopRequireDefault(_getValue);

var _contextShape = require('./utils/contextShape');

var _contextShape2 = _interopRequireDefault(_contextShape);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var Field = (0, _mobxReact.observer)(_class = (_temp = _class2 = function (_Component) {
  _inherits(Field, _Component);

  function Field() {
    _classCallCheck(this, Field);

    return _possibleConstructorReturn(this, (Field.__proto__ || Object.getPrototypeOf(Field)).apply(this, arguments));
  }

  _createClass(Field, [{
    key: 'componentWillMount',
    value: function componentWillMount() {
      var _props = this.props;
      var name = _props.name;
      var index = _props.index;
      var defaultValue = _props.defaultValue;
      var validate = _props.validate;


      (0, _invariant2.default)(this.context.mobxForms, '[mobx-forms] Field must be in a component decorated with "mobxForm"');

      var _context$mobxForms = this.context.mobxForms;
      var form = _context$mobxForms.form;
      var context = _context$mobxForms.context;
      var flatArray = _context$mobxForms.flatArray;


      if (context === '') {
        (0, _invariant2.default)(!Number.isInteger(index), '[mobx-forms] "index" can only be passed to components inside ArrayField');
      } else {
        (0, _invariant2.default)(Number.isInteger(index), '[mobx-forms] "index" must be passed to ArrayField components');
      }

      this.pos = !flatArray && Number.isInteger(index) ? context + '#' + index : context;
      this.field = new _FieldStore2.default({
        name: name,
        value: defaultValue,
        defaultValue: defaultValue,
        validate: validate
      });

      if (flatArray && Number.isInteger(index)) {
        form.addField(this.pos, index, this.field);
      } else {
        form.addField(this.pos, name, this.field);
      }
    }
  }, {
    key: 'componentWillUnmount',
    value: function componentWillUnmount() {
      var name = this.props.name;
      var form = this.context.mobxForms.form;


      form.removeField(this.pos, name);
    }
  }, {
    key: 'handleChange',
    value: function handleChange(ev) {
      this.field.value = (0, _getValue2.default)(ev);
    }
  }, {
    key: 'handleFocus',
    value: function handleFocus() {
      this.field.active = true;
      this.field.visited = true;
    }
  }, {
    key: 'handleBlur',
    value: function handleBlur() {
      this.field.active = false;
      this.field.touched = true;
    }
  }, {
    key: 'render',
    value: function render() {
      var _this2 = this;

      var _props2 = this.props;
      var component = _props2.component;

      var props = _objectWithoutProperties(_props2, ['component']);

      props.onChange = function (ev) {
        return _this2.handleChange(ev);
      };
      props.onFocus = function (ev) {
        return _this2.handleFocus(ev);
      };
      props.onBlur = function (ev) {
        return _this2.handleBlur(ev);
      };

      var _prepareProps = (0, _prepareProps3.default)(_ramda2.default.merge(props, this.field.props));

      var input = _prepareProps.input;
      var meta = _prepareProps.meta;
      var custom = _prepareProps.custom;


      if (typeof component === 'string') {
        return _react2.default.createElement(component, _ramda2.default.merge(custom, input));
      }

      return _react2.default.createElement(component, _ramda2.default.merge(custom, { input: input, meta: meta }));
    }
  }]);

  return Field;
}(_react.Component), _class2.propTypes = {
  name: _react.PropTypes.string.isRequired,
  component: _react.PropTypes.oneOfType([_react.PropTypes.func, _react.PropTypes.string]).isRequired,
  // default:
  validate: _react.PropTypes.func.isRequired,
  defaultValue: _react.PropTypes.string.isRequired,
  // optional:
  index: _react.PropTypes.number
}, _class2.defaultProps = {
  validate: function validate() {
    return null;
  },
  defaultValue: ''
}, _class2.contextTypes = {
  mobxForms: _react.PropTypes.shape(_contextShape2.default).isRequired
}, _temp)) || _class;

exports.default = Field;