'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = undefined;

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _class, _class2, _temp;

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _mobxReact = require('mobx-react');

var _ramda = require('ramda');

var _ramda2 = _interopRequireDefault(_ramda);

var _invariant = require('invariant');

var _invariant2 = _interopRequireDefault(_invariant);

var _consts = require('./utils/consts');

var _contextShape = require('./utils/contextShape');

var _contextShape2 = _interopRequireDefault(_contextShape);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var FieldArray = (0, _mobxReact.observer)(_class = (_temp = _class2 = function (_Component) {
  _inherits(FieldArray, _Component);

  function FieldArray() {
    _classCallCheck(this, FieldArray);

    return _possibleConstructorReturn(this, (FieldArray.__proto__ || Object.getPrototypeOf(FieldArray)).apply(this, arguments));
  }

  _createClass(FieldArray, [{
    key: 'getChildContext',
    value: function getChildContext() {
      var _props = this.props;
      var name = _props.name;
      var index = _props.index;
      var flat = _props.flat;
      var _context$mobxForms = this.context.mobxForms;
      var form = _context$mobxForms.form;
      var context = _context$mobxForms.context;


      return {
        mobxForms: {
          form: form,
          context: Number.isInteger(index) ? context + '#' + index + '.' + name : name,
          flatArray: flat
        }
      };
    }
  }, {
    key: 'componentWillMount',
    value: function componentWillMount() {
      var _this2 = this;

      var _props2 = this.props;
      var name = _props2.name;
      var index = _props2.index;
      var flat = _props2.flat;


      (0, _invariant2.default)(this.context.mobxForms, '[mobx-forms] FieldArray must be in a component decorated with "mobxForm"');

      var _context$mobxForms2 = this.context.mobxForms;
      var form = _context$mobxForms2.form;
      var context = _context$mobxForms2.context;
      var flatArray = _context$mobxForms2.flatArray;


      if (context === '') {
        (0, _invariant2.default)(!Number.isInteger(index), '[mobx-forms] "index" can only be passed to components inside ArrayField');
      } else {
        (0, _invariant2.default)(Number.isInteger(index), '[mobx-forms] "index" must be passed to ArrayField components');
      }

      this.pos = Number.isInteger(index) ? context + '#' + index : '';
      this.location = Number.isInteger(index) ? context + '#' + index + '.' + name : name;
      this.fields = {
        map: function map(fn) {
          return form.map(_this2.location, fn);
        },
        push: function push() {
          return form.push(_this2.location, flat ? null : {});
        },
        pop: function pop() {
          return form.pop(_this2.location);
        },
        unshift: function unshift() {
          return form.unshift(_this2.location, flat ? null : {});
        },
        shift: function shift() {
          return form.shift(_this2.location);
        }
      };

      (0, _invariant2.default)(!flatArray, '[mobx-forms] FieldArray cannot be located within a flat FieldArray');

      form.addFieldArray(this.pos, name);
    }
  }, {
    key: 'componentWillUnmount',
    value: function componentWillUnmount() {
      var name = this.props.name;
      var form = this.context.mobxForms.form;


      form.removeField(this.pos, name);
    }
  }, {
    key: 'render',
    value: function render() {
      var _props3 = this.props;
      var component = _props3.component;

      var rest = _objectWithoutProperties(_props3, ['component']);

      return _react2.default.createElement(component, _ramda2.default.merge(_ramda2.default.omit(_consts.ARRAY_IGNORE_PROPS, rest), {
        fields: this.fields
      }));
    }
  }]);

  return FieldArray;
}(_react.Component), _class2.propTypes = {
  name: _react.PropTypes.string.isRequired,
  component: _react.PropTypes.oneOfType([_react.PropTypes.func, _react.PropTypes.string]).isRequired,
  // defaulted:
  flat: _react.PropTypes.bool.isRequired,
  // optional:
  index: _react.PropTypes.number
}, _class2.defaultProps = {
  flat: false
}, _class2.contextTypes = {
  mobxForms: _react.PropTypes.shape(_contextShape2.default).isRequired
}, _class2.childContextTypes = {
  mobxForms: _react.PropTypes.shape(_contextShape2.default).isRequired
}, _temp)) || _class;

exports.default = FieldArray;