'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = undefined;

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _desc, _value, _class, _descriptor;

var _mobx = require('mobx');

var _invariant = require('invariant');

var _invariant2 = _interopRequireDefault(_invariant);

var _ramda = require('ramda');

var _ramda2 = _interopRequireDefault(_ramda);

var _traverse = require('../utils/traverse');

var _traverse2 = _interopRequireDefault(_traverse);

var _mapForm = require('../utils/mapForm');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _initDefineProp(target, property, descriptor, context) {
  if (!descriptor) return;
  Object.defineProperty(target, property, {
    enumerable: descriptor.enumerable,
    configurable: descriptor.configurable,
    writable: descriptor.writable,
    value: descriptor.initializer ? descriptor.initializer.call(context) : void 0
  });
}

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _applyDecoratedDescriptor(target, property, decorators, descriptor, context) {
  var desc = {};
  Object['ke' + 'ys'](descriptor).forEach(function (key) {
    desc[key] = descriptor[key];
  });
  desc.enumerable = !!desc.enumerable;
  desc.configurable = !!desc.configurable;

  if ('value' in desc || desc.initializer) {
    desc.writable = true;
  }

  desc = decorators.slice().reverse().reduce(function (desc, decorator) {
    return decorator(target, property, desc) || desc;
  }, desc);

  if (context && desc.initializer !== void 0) {
    desc.value = desc.initializer ? desc.initializer.call(context) : void 0;
    desc.initializer = undefined;
  }

  if (desc.initializer === void 0) {
    Object['define' + 'Property'](target, property, desc);
    desc = null;
  }

  return desc;
}

function _initializerWarningHelper(descriptor, context) {
  throw new Error('Decorating class property failed. Please ensure that transform-class-properties is enabled.');
}

var FormStore = (_class = function () {
  function FormStore() {
    _classCallCheck(this, FormStore);

    _initDefineProp(this, 'fields', _descriptor, this);
  }

  _createClass(FormStore, [{
    key: 'addField',
    value: function addField(context, name, field) {
      var base = (0, _traverse2.default)(this.fields, context);
      (0, _invariant2.default)(!base[name], '[mobx-forms] Tried to mount a Field \'' + name + '\' twice. Names must be unique!');
      base[name] = field;
    }
  }, {
    key: 'addFieldArray',
    value: function addFieldArray(context, name) {
      var base = (0, _traverse2.default)(this.fields, context);
      (0, _invariant2.default)(!base[name], '[mobx-forms] Tried to mount a FieldArray \'' + name + '\' twice. Names must be unique!');
      base[name] = (0, _mobx.observable)([]);
    }
  }, {
    key: 'removeField',
    value: function removeField(context, name) {
      var base = (0, _traverse2.default)(this.fields, context);
      delete base[name];
    }

    // Array functions
    // ---

  }, {
    key: 'map',
    value: function map(context, fn) {
      var base = (0, _traverse2.default)(this.fields, context);
      return _ramda2.default.map(fn, _ramda2.default.addIndex(_ramda2.default.map)(function (_, i) {
        return i;
      }, base));
    }
  }, {
    key: 'push',
    value: function push(context, field) {
      var base = (0, _traverse2.default)(this.fields, context);
      base.push(field);
    }
  }, {
    key: 'pop',
    value: function pop(context) {
      var base = (0, _traverse2.default)(this.fields, context);
      base.pop();
    }
  }, {
    key: 'unshift',
    value: function unshift(context, field) {
      var base = (0, _traverse2.default)(this.fields, context);
      base.unshift(field);
    }
  }, {
    key: 'shift',
    value: function shift(context) {
      var base = (0, _traverse2.default)(this.fields, context);
      base.shift();
    }
  }, {
    key: 'values',
    get: function get() {
      return (0, _mapForm.mapDeep)(_ramda2.default.prop('value'), (0, _mobx.toJS)(this.fields));
    }
  }, {
    key: 'errors',
    get: function get() {
      return (0, _mapForm.mapDeep)(_ramda2.default.prop('error'), (0, _mobx.toJS)(this.fields));
    }
  }, {
    key: 'valid',
    get: function get() {
      return _ramda2.default.all(_ramda2.default.equals(null), (0, _mapForm.mapFlat)(_ramda2.default.prop('error'), (0, _mobx.toJS)(this.fields)));
    }
  }]);

  return FormStore;
}(), (_descriptor = _applyDecoratedDescriptor(_class.prototype, 'fields', [_mobx.observable], {
  enumerable: true,
  initializer: function initializer() {
    return {};
  }
}), _applyDecoratedDescriptor(_class.prototype, 'values', [_mobx.computed], Object.getOwnPropertyDescriptor(_class.prototype, 'values'), _class.prototype), _applyDecoratedDescriptor(_class.prototype, 'errors', [_mobx.computed], Object.getOwnPropertyDescriptor(_class.prototype, 'errors'), _class.prototype), _applyDecoratedDescriptor(_class.prototype, 'valid', [_mobx.computed], Object.getOwnPropertyDescriptor(_class.prototype, 'valid'), _class.prototype)), _class);
exports.default = FormStore;