'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _mobxReact = require('mobx-react');

var _invariant = require('invariant');

var _invariant2 = _interopRequireDefault(_invariant);

var _ramda = require('ramda');

var _ramda2 = _interopRequireDefault(_ramda);

var _FormsStore = require('./FormsStore');

var _FormsStore2 = _interopRequireDefault(_FormsStore);

var _consts = require('./utils/consts');

var _contextShape = require('./utils/contextShape');

var _contextShape2 = _interopRequireDefault(_contextShape);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

/**
 * Decorator for a component that will be the root of a form.
 *
 * @param options
 * @prop options.form: string - the form's name
 */
var mobxForm = function mobxForm(options) {
  (0, _invariant2.default)(options.form, '[mobx-forms] "form" option is required on the "mobxForm" decorator.');

  return function (WrappedComponent) {
    var FormWrap = function (_Component) {
      _inherits(FormWrap, _Component);

      function FormWrap() {
        _classCallCheck(this, FormWrap);

        return _possibleConstructorReturn(this, (FormWrap.__proto__ || Object.getPrototypeOf(FormWrap)).apply(this, arguments));
      }

      _createClass(FormWrap, [{
        key: 'getChildContext',
        value: function getChildContext() {
          return {
            mobxForms: {
              form: this.props.mobxForms.forms[options.form],
              context: '',
              flatArray: false
            }
          };
        }
      }, {
        key: 'componentWillMount',
        value: function componentWillMount() {
          this.props.mobxForms.addForm(options.form);
        }
      }, {
        key: 'componentWillUnmount',
        value: function componentWillUnmount() {
          this.props.mobxForms.removeForm(options.form);
        }
      }, {
        key: 'render',
        value: function render() {
          var props = _ramda2.default.omit([_consts.MOBX_FORMS], this.props);

          props[options.form] = this.props.mobxForms.forms[options.form];

          return _react2.default.createElement(WrappedComponent, props);
        }
      }]);

      return FormWrap;
    }(_react.Component);

    FormWrap.propTypes = {
      mobxForms: _react.PropTypes.instanceOf(_FormsStore2.default).isRequired
    };

    FormWrap.childContextTypes = {
      mobxForms: _react.PropTypes.shape(_contextShape2.default).isRequired
    };

    return (0, _mobxReact.inject)(_consts.MOBX_FORMS)(FormWrap);
  };
};

exports.default = mobxForm;