'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
var getSelectedValues = function getSelectedValues(options) {
  return options.filter(function (option) {
    return option.selected;
  }).map(function (option) {
    return option.value;
  });
};

var isEvent = function isEvent(ev) {
  return Boolean(ev && ev.preventDefault && ev.stopPropagation);
};

var getValue = function getValue(ev) {
  if (!isEvent(ev)) {
    return ev;
  }

  var _ev$target = ev.target;
  var type = _ev$target.type;
  var value = _ev$target.value;
  var checked = _ev$target.checked;
  var files = _ev$target.files;
  var options = _ev$target.options;
  var dataTransfer = ev.dataTransfer;


  switch (type) {
    case 'checkbox':
      return checked;
    case 'file':
      return files || dataTransfer && dataTransfer.files;
    case 'select-multiple':
      return getSelectedValues(options);
    case 'range':
    case 'number':
      return Number(value);
    default:
      return value;
  }
};

exports.default = getValue;