'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.mapFlat = exports.mapDeep = undefined;

var _ramda = require('ramda');

var _ramda2 = _interopRequireDefault(_ramda);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var isField = _ramda2.default.has('__mobxField');

var mapDeep = exports.mapDeep = function mapDeep(fn, form) {
  return _ramda2.default.map(function (val) {
    return isField(val) ? fn(val) : mapDeep(fn, val);
  }, form);
};

var toArrays = _ramda2.default.map(function (val) {
  return isField(val) ? val : toArrays(_ramda2.default.values(val));
});

var mapFlat = exports.mapFlat = function mapFlat(fn, form) {
  return _ramda2.default.compose(_ramda2.default.map(fn), _ramda2.default.flatten, toArrays, _ramda2.default.values)(form);
};