'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _ramda = require('ramda');

var _ramda2 = _interopRequireDefault(_ramda);

var _consts = require('./consts');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var maybeCheckProps = function maybeCheckProps(all) {
  if (typeof all.value === 'boolean') {
    return _ramda2.default.merge(all, { checked: all.value });
  }
  return all;
};

var separateProps = function separateProps(all) {
  return {
    input: _ramda2.default.pick(_consts.INPUT_PROPS, all),
    meta: _ramda2.default.pick(_consts.META_PROPS, all),
    custom: _ramda2.default.omit(_consts.IGNORE_PROPS, all)
  };
};

// Order matters!
// Separate always last
exports.default = _ramda2.default.compose(separateProps, maybeCheckProps);